<template>
  <rui-form :errors="errors"
            model="patch"
            :loading="loading"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-field input-id="patchFormName" :label="$t('activerecord.attributes.patch.name')">
      <input id="patchFormName" v-model="inputs.name" type="text">
    </rui-field>

    <template v-if="!patch?.isVirtual && patch?.id">
      <rui-field input-id="patchFormLayer" :label="$t('activerecord.attributes.patch.layer')">
        <select id="patchFormLayer" v-model="inputs.layer_id">
          <option v-for="layer in layers" :key="layer.id" :value="layer.id">{{ layer.name }}</option>
        </select>
      </rui-field>

      <rui-field :help="$t('js.patch.form.make_virtual_help')">
        <label>
          <input v-model="makeVirtual" type="checkbox"> {{ $t('js.patch.form.make_virtual') }}
        </label>
      </rui-field>
    </template>
  </rui-form>
</template>

<script>
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'

import Patch from '../../../../classes/models/Patch'

export default {
  name: 'GpaPatchForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiField, RuiForm },
  props: {
    patch: { required: false, type: Patch, default: null },
  },
  data () {
    return {
      loading: false,
      inputs: { ...this.resetInputs() },
      errors: null,
      makeVirtual: false,
    }
  },
  computed: {
    layers () { return this.$store.getters.layers },
    currentMapId () { return parseInt(this.$route.params.mapId, 10) },
  },
  methods: {
    resetInputs () {
      return {
        id: this.patch?.id,
        name: this.patch?.name || '',
        layer_id: this.patch?.layerId || null,
      }
    },
    save () {
      this.errors = null
      const payload = {
        ...this.inputs,
        map_id: this.currentMapId,
      }

      this.loading = true
      let request = null
      if (this.makeVirtual) {
        request = this.$store.dispatch('virtualizePatch', { payload, originalPatch: this.patch })
      } else {
        request = this.$store.dispatch(this.patch ? 'updatePatch' : 'createPatch', { payload })
      }

      request
        .then(() => { this.$emit('saved') })
        .catch((error) => { this.errors = error })
        .then(() => { this.loading = false })
    },
  },
}
</script>
